rm -f *.crt *.key *.csr
for a in root inter test; do
	rm -rf ${a}CA/
	mkdir -p ${a}CA/newcerts
	touch ${a}CA/index.txt
	echo 01 > ${a}CA/serial
done
rm -rf certs

BASESUBJ="/C=GB/ST=Derbyshire/L=Derby/O=Mosquitto Project/OU=Testing"

openssl genrsa -out test-root-ca.key 1024
openssl req -new -x509 -days 3650 -key test-root-ca.key -out test-root-ca.crt -config openssl.cnf -subj "${BASESUBJ}/CN=Root CA/"

openssl genrsa -out test-inter-ca.key 1024
openssl req -out test-inter-ca.csr -key test-inter-ca.key -new -config openssl.cnf -subj "${BASESUBJ}/CN=Inter CA/"
openssl ca -config openssl.cnf -name CA_root -extensions v3_ca -out test-inter-ca.crt -infiles test-inter-ca.csr

openssl genrsa -out test-signing-ca.key 1024
openssl req -out test-signing-ca.csr -key test-signing-ca.key -new -config openssl.cnf -subj "${BASESUBJ}/CN=Signing CA/"
openssl ca -config openssl.cnf -name CA_inter -extensions v3_ca -out test-signing-ca.crt -infiles test-signing-ca.csr

openssl genrsa -out server.key 1024
openssl req -new -days 1825 -key server.key -out server.csr -config openssl.cnf -subj "${BASESUBJ}/CN=localhost/"
openssl ca -config openssl.cnf -name CA_default -out server.crt -infiles server.csr 

cat test-signing-ca.crt test-inter-ca.crt test-root-ca.crt > all.crt 

mkdir certs
cp test-signing-ca.crt test-inter-ca.crt test-root-ca.crt certs
c_rehash certs
